# Source code for azure.mgmt.storagesync.operations._cloud_endpoints_operations

    # coding=utf-8
    # --------------------------------------------------------------------------
    # Copyright (c) Microsoft Corporation. All rights reserved.
    # Licensed under the MIT License. See License.txt in the project root for
    # license information.
    #
    # Code generated by Microsoft (R) AutoRest Code Generator.
    # Changes may cause incorrect behavior and will be lost if the code is
    # regenerated.
    # --------------------------------------------------------------------------

    import uuid
    from msrest.pipeline import ClientRawResponse
    from msrest.polling import LROPoller, NoPolling
    from msrestazure.polling.arm_polling import ARMPolling

    from .. import models

    class CloudEndpointsOperations(object):
        """CloudEndpointsOperations operations.

        You should not instantiate directly this class, but create a Client instance that will create it for you and attach it as attribute.

        :param client: Client for service requests.
        :param config: Configuration of service client.
        :param serializer: An object model serializer.
        :param deserializer: An object model deserializer.
        :ivar api_version: The API version to use for this operation. Constant value: "2019-06-01".
        """

        models = models

        def __init__(self, client, config, serializer, deserializer):

            self._client = client
            self._serialize = serializer
            self._deserialize = deserializer
            self.api_version = "2019-06-01"

            self.config = config

        def _create_initial(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, parameters, custom_headers=None, raw=False, **operation_config):
            # Construct URL
            url = self.create.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str'),
                'cloudEndpointName': self._serialize.url("cloud_endpoint_name", cloud_endpoint_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(parameters, 'CloudEndpointCreateParameters')

            # Construct and send request
            request = self._client.put(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200, 202]:
                raise models.StorageSyncErrorException(self._deserialize, response)

            deserialized = None
            header_dict = {}

            if response.status_code == 200:
                deserialized = self._deserialize('CloudEndpoint', response)
                header_dict = {
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                    'Azure-AsyncOperation': 'str',
                    'Location': 'str',
                    'Retry-After': 'str',
                }

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                client_raw_response.add_headers(header_dict)
                return client_raw_response

            return deserialized

        def create(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, parameters, custom_headers=None, raw=False, polling=True, **operation_config):
            """Create a new CloudEndpoint.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param cloud_endpoint_name: Name of Cloud Endpoint object.
            :type cloud_endpoint_name: str
            :param parameters: Body of Cloud Endpoint resource.
            :type parameters:
             ~azure.mgmt.storagesync.models.CloudEndpointCreateParameters
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: The poller return type is ClientRawResponse, the
             direct response alongside the deserialized response
            :param polling: True for ARMPolling, False for no polling, or a
             polling object for personal polling strategy
            :return: An instance of LROPoller that returns CloudEndpoint or
             ClientRawResponse<CloudEndpoint> if raw==True
            :rtype:
             ~msrestazure.azure_operation.AzureOperationPoller[~azure.mgmt.storagesync.models.CloudEndpoint]
             or
             ~msrestazure.azure_operation.AzureOperationPoller[~msrest.pipeline.ClientRawResponse[~azure.mgmt.storagesync.models.CloudEndpoint]]
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            raw_result = self._create_initial(
                resource_group_name=resource_group_name,
                storage_sync_service_name=storage_sync_service_name,
                sync_group_name=sync_group_name,
                cloud_endpoint_name=cloud_endpoint_name,
                parameters=parameters,
                custom_headers=custom_headers,
                raw=True,
                **operation_config
            )

            def get_long_running_output(response):
                header_dict = {
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                    'Azure-AsyncOperation': 'str',
                    'Location': 'str',
                    'Retry-After': 'str',
                }
                deserialized = self._deserialize('CloudEndpoint', response)

                if raw:
                    client_raw_response = ClientRawResponse(deserialized, response)
                    client_raw_response.add_headers(header_dict)
                    return client_raw_response

                return deserialized

            lro_delay = operation_config.get(
                'long_running_operation_timeout',
                self.config.long_running_operation_timeout)
            if polling is True: polling_method = ARMPolling(lro_delay, **operation_config)
            elif polling is False: polling_method = NoPolling()
            else: polling_method = polling
            return LROPoller(self._client, raw_result, get_long_running_output, polling_method)
        create.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints/{cloudEndpointName}'}

        def get(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, custom_headers=None, raw=False, **operation_config):
            """Get a given CloudEndpoint.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param cloud_endpoint_name: Name of Cloud Endpoint object.
            :type cloud_endpoint_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: CloudEndpoint or ClientRawResponse if raw=true
            :rtype: ~azure.mgmt.storagesync.models.CloudEndpoint or
             ~msrest.pipeline.ClientRawResponse
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            # Construct URL
            url = self.get.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str'),
                'cloudEndpointName': self._serialize.url("cloud_endpoint_name", cloud_endpoint_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                raise models.StorageSyncErrorException(self._deserialize, response)

            header_dict = {}
            deserialized = None
            if response.status_code == 200:
                deserialized = self._deserialize('CloudEndpoint', response)
                header_dict = {
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                }

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                client_raw_response.add_headers(header_dict)
                return client_raw_response

            return deserialized
        get.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints/{cloudEndpointName}'}

        def _delete_initial(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, custom_headers=None, raw=False, **operation_config):
            # Construct URL
            url = self.delete.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str'),
                'cloudEndpointName': self._serialize.url("cloud_endpoint_name", cloud_endpoint_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.delete(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200, 202, 204]:
                raise models.StorageSyncErrorException(self._deserialize, response)

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                header_dict = {
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                    'Azure-AsyncOperation': 'str',
                    'Location': 'str',
                    'Retry-After': 'str',
                }
                client_raw_response.add_headers(header_dict)
                return client_raw_response

        def delete(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, custom_headers=None, raw=False, polling=True, **operation_config):
            """Delete a given CloudEndpoint.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param cloud_endpoint_name: Name of Cloud Endpoint object.
            :type cloud_endpoint_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: The poller return type is ClientRawResponse, the
             direct response alongside the deserialized response
            :param polling: True for ARMPolling, False for no polling, or a
             polling object for personal polling strategy
            :return: An instance of LROPoller that returns None or
             ClientRawResponse<None> if raw==True
            :rtype: ~msrestazure.azure_operation.AzureOperationPoller[None] or
             ~msrestazure.azure_operation.AzureOperationPoller[~msrest.pipeline.ClientRawResponse[None]]
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            raw_result = self._delete_initial(
                resource_group_name=resource_group_name,
                storage_sync_service_name=storage_sync_service_name,
                sync_group_name=sync_group_name,
                cloud_endpoint_name=cloud_endpoint_name,
                custom_headers=custom_headers,
                raw=True,
                **operation_config
            )

            def get_long_running_output(response):
                if raw:
                    client_raw_response = ClientRawResponse(None, response)
                    client_raw_response.add_headers({
                        'x-ms-request-id': 'str',
                        'x-ms-correlation-request-id': 'str',
                        'Azure-AsyncOperation': 'str',
                        'Location': 'str',
                        'Retry-After': 'str',
                    })
                    return client_raw_response

            lro_delay = operation_config.get(
                'long_running_operation_timeout',
                self.config.long_running_operation_timeout)
            if polling is True: polling_method = ARMPolling(lro_delay, **operation_config)
            elif polling is False: polling_method = NoPolling()
            else: polling_method = polling
            return LROPoller(self._client, raw_result, get_long_running_output, polling_method)
        delete.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints/{cloudEndpointName}'}

        def list_by_sync_group(
                self, resource_group_name, storage_sync_service_name, sync_group_name, custom_headers=None, raw=False, **operation_config):
            """Get a CloudEndpoint List.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of CloudEndpoint
            :rtype:
             ~azure.mgmt.storagesync.models.CloudEndpointPaged[~azure.mgmt.storagesync.models.CloudEndpoint]
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            def prepare_request(next_link=None):
                if not next_link:
                    # Construct URL
                    url = self.list_by_sync_group.metadata['url']
                    path_format_arguments = {
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                        'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                        'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                return request

            def internal_paging(next_link=None):
                request = prepare_request(next_link)

                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    raise models.StorageSyncErrorException(self._deserialize, response)

                return response

            # Deserialize response
            header_dict = None
            if raw:
                header_dict = {}
            deserialized = models.CloudEndpointPaged(internal_paging, self._deserialize.dependencies, header_dict)

            return deserialized
        list_by_sync_group.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints'}

        def _pre_backup_initial(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, azure_file_share=None, custom_headers=None, raw=False, **operation_config):
            parameters = models.BackupRequest(azure_file_share=azure_file_share)

            # Construct URL
            url = self.pre_backup.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str'),
                'cloudEndpointName': self._serialize.url("cloud_endpoint_name", cloud_endpoint_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(parameters, 'BackupRequest')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200, 202]:
                raise models.StorageSyncErrorException(self._deserialize, response)

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                header_dict = {
                    'Location': 'str',
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                }
                client_raw_response.add_headers(header_dict)
                return client_raw_response

        def pre_backup(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, azure_file_share=None, custom_headers=None, raw=False, polling=True, **operation_config):
            """Pre Backup a given CloudEndpoint.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param cloud_endpoint_name: Name of Cloud Endpoint object.
            :type cloud_endpoint_name: str
            :param azure_file_share: Azure File Share.
            :type azure_file_share: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: The poller return type is ClientRawResponse, the
             direct response alongside the deserialized response
            :param polling: True for ARMPolling, False for no polling, or a
             polling object for personal polling strategy
            :return: An instance of LROPoller that returns None or
             ClientRawResponse<None> if raw==True
            :rtype: ~msrestazure.azure_operation.AzureOperationPoller[None] or
             ~msrestazure.azure_operation.AzureOperationPoller[~msrest.pipeline.ClientRawResponse[None]]
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            raw_result = self._pre_backup_initial(
                resource_group_name=resource_group_name,
                storage_sync_service_name=storage_sync_service_name,
                sync_group_name=sync_group_name,
                cloud_endpoint_name=cloud_endpoint_name,
                azure_file_share=azure_file_share,
                custom_headers=custom_headers,
                raw=True,
                **operation_config
            )

            def get_long_running_output(response):
                if raw:
                    client_raw_response = ClientRawResponse(None, response)
                    client_raw_response.add_headers({
                        'Location': 'str',
                        'x-ms-request-id': 'str',
                        'x-ms-correlation-request-id': 'str',
                    })
                    return client_raw_response

            lro_delay = operation_config.get(
                'long_running_operation_timeout',
                self.config.long_running_operation_timeout)
            if polling is True: polling_method = ARMPolling(lro_delay, **operation_config)
            elif polling is False: polling_method = NoPolling()
            else: polling_method = polling
            return LROPoller(self._client, raw_result, get_long_running_output, polling_method)
        pre_backup.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints/{cloudEndpointName}/prebackup'}

        def _post_backup_initial(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, azure_file_share=None, custom_headers=None, raw=False, **operation_config):
            parameters = models.BackupRequest(azure_file_share=azure_file_share)

            # Construct URL
            url = self.post_backup.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str'),
                'cloudEndpointName': self._serialize.url("cloud_endpoint_name", cloud_endpoint_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(parameters, 'BackupRequest')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200, 202]:
                raise models.StorageSyncErrorException(self._deserialize, response)

            deserialized = None
            header_dict = {}

            if response.status_code == 200:
                deserialized = self._deserialize('PostBackupResponse', response)
                header_dict = {
                    'Location': 'str',
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                }

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                client_raw_response.add_headers(header_dict)
                return client_raw_response

            return deserialized

        def post_backup(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, azure_file_share=None, custom_headers=None, raw=False, polling=True, **operation_config):
            """Post Backup a given CloudEndpoint.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param cloud_endpoint_name: Name of Cloud Endpoint object.
            :type cloud_endpoint_name: str
            :param azure_file_share: Azure File Share.
            :type azure_file_share: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: The poller return type is ClientRawResponse, the
             direct response alongside the deserialized response
            :param polling: True for ARMPolling, False for no polling, or a
             polling object for personal polling strategy
            :return: An instance of LROPoller that returns PostBackupResponse or
             ClientRawResponse<PostBackupResponse> if raw==True
            :rtype:
             ~msrestazure.azure_operation.AzureOperationPoller[~azure.mgmt.storagesync.models.PostBackupResponse]
             or
             ~msrestazure.azure_operation.AzureOperationPoller[~msrest.pipeline.ClientRawResponse[~azure.mgmt.storagesync.models.PostBackupResponse]]
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            raw_result = self._post_backup_initial(
                resource_group_name=resource_group_name,
                storage_sync_service_name=storage_sync_service_name,
                sync_group_name=sync_group_name,
                cloud_endpoint_name=cloud_endpoint_name,
                azure_file_share=azure_file_share,
                custom_headers=custom_headers,
                raw=True,
                **operation_config
            )

            def get_long_running_output(response):
                header_dict = {
                    'Location': 'str',
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                }
                deserialized = self._deserialize('PostBackupResponse', response)

                if raw:
                    client_raw_response = ClientRawResponse(deserialized, response)
                    client_raw_response.add_headers(header_dict)
                    return client_raw_response

                return deserialized

            lro_delay = operation_config.get(
                'long_running_operation_timeout',
                self.config.long_running_operation_timeout)
            if polling is True: polling_method = ARMPolling(lro_delay, **operation_config)
            elif polling is False: polling_method = NoPolling()
            else: polling_method = polling
            return LROPoller(self._client, raw_result, get_long_running_output, polling_method)
        post_backup.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints/{cloudEndpointName}/postbackup'}

        def _pre_restore_initial(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, parameters, custom_headers=None, raw=False, **operation_config):
            # Construct URL
            url = self.pre_restore.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str'),
                'cloudEndpointName': self._serialize.url("cloud_endpoint_name", cloud_endpoint_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(parameters, 'PreRestoreRequest')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200, 202]:
                raise models.StorageSyncErrorException(self._deserialize, response)

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                header_dict = {
                    'Location': 'str',
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                }
                client_raw_response.add_headers(header_dict)
                return client_raw_response

        def pre_restore(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, parameters, custom_headers=None, raw=False, polling=True, **operation_config):
            """Pre Restore a given CloudEndpoint.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param cloud_endpoint_name: Name of Cloud Endpoint object.
            :type cloud_endpoint_name: str
            :param parameters: Body of Cloud Endpoint object.
            :type parameters: ~azure.mgmt.storagesync.models.PreRestoreRequest
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: The poller return type is ClientRawResponse, the
             direct response alongside the deserialized response
            :param polling: True for ARMPolling, False for no polling, or a
             polling object for personal polling strategy
            :return: An instance of LROPoller that returns None or
             ClientRawResponse<None> if raw==True
            :rtype: ~msrestazure.azure_operation.AzureOperationPoller[None] or
             ~msrestazure.azure_operation.AzureOperationPoller[~msrest.pipeline.ClientRawResponse[None]]
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            raw_result = self._pre_restore_initial(
                resource_group_name=resource_group_name,
                storage_sync_service_name=storage_sync_service_name,
                sync_group_name=sync_group_name,
                cloud_endpoint_name=cloud_endpoint_name,
                parameters=parameters,
                custom_headers=custom_headers,
                raw=True,
                **operation_config
            )

            def get_long_running_output(response):
                if raw:
                    client_raw_response = ClientRawResponse(None, response)
                    client_raw_response.add_headers({
                        'Location': 'str',
                        'x-ms-request-id': 'str',
                        'x-ms-correlation-request-id': 'str',
                    })
                    return client_raw_response

            lro_delay = operation_config.get(
                'long_running_operation_timeout',
                self.config.long_running_operation_timeout)
            if polling is True: polling_method = ARMPolling(lro_delay, **operation_config)
            elif polling is False: polling_method = NoPolling()
            else: polling_method = polling
            return LROPoller(self._client, raw_result, get_long_running_output, polling_method)
        pre_restore.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints/{cloudEndpointName}/prerestore'}

        def restoreheartbeat(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, custom_headers=None, raw=False, **operation_config):
            """Restore Heartbeat a given CloudEndpoint.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param cloud_endpoint_name: Name of Cloud Endpoint object.
            :type cloud_endpoint_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: None or ClientRawResponse if raw=true
            :rtype: None or ~msrest.pipeline.ClientRawResponse
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            # Construct URL
            url = self.restoreheartbeat.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str'),
                'cloudEndpointName': self._serialize.url("cloud_endpoint_name", cloud_endpoint_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                raise models.StorageSyncErrorException(self._deserialize, response)

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                client_raw_response.add_headers({
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                })
                return client_raw_response
        restoreheartbeat.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints/{cloudEndpointName}/restoreheartbeat'}

        def _post_restore_initial(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, parameters, custom_headers=None, raw=False, **operation_config):
            # Construct URL
            url = self.post_restore.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str'),
                'cloudEndpointName': self._serialize.url("cloud_endpoint_name", cloud_endpoint_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(parameters, 'PostRestoreRequest')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200, 202]:
                raise models.StorageSyncErrorException(self._deserialize, response)

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                header_dict = {
                    'Location': 'str',
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                }
                client_raw_response.add_headers(header_dict)
                return client_raw_response

        def post_restore(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, parameters, custom_headers=None, raw=False, polling=True, **operation_config):
            """Post Restore a given CloudEndpoint.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param cloud_endpoint_name: Name of Cloud Endpoint object.
            :type cloud_endpoint_name: str
            :param parameters: Body of Cloud Endpoint object.
            :type parameters: ~azure.mgmt.storagesync.models.PostRestoreRequest
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: The poller return type is ClientRawResponse, the
             direct response alongside the deserialized response
            :param polling: True for ARMPolling, False for no polling, or a
             polling object for personal polling strategy
            :return: An instance of LROPoller that returns None or
             ClientRawResponse<None> if raw==True
            :rtype: ~msrestazure.azure_operation.AzureOperationPoller[None] or
             ~msrestazure.azure_operation.AzureOperationPoller[~msrest.pipeline.ClientRawResponse[None]]
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            raw_result = self._post_restore_initial(
                resource_group_name=resource_group_name,
                storage_sync_service_name=storage_sync_service_name,
                sync_group_name=sync_group_name,
                cloud_endpoint_name=cloud_endpoint_name,
                parameters=parameters,
                custom_headers=custom_headers,
                raw=True,
                **operation_config
            )

            def get_long_running_output(response):
                if raw:
                    client_raw_response = ClientRawResponse(None, response)
                    client_raw_response.add_headers({
                        'Location': 'str',
                        'x-ms-request-id': 'str',
                        'x-ms-correlation-request-id': 'str',
                    })
                    return client_raw_response

            lro_delay = operation_config.get(
                'long_running_operation_timeout',
                self.config.long_running_operation_timeout)
            if polling is True: polling_method = ARMPolling(lro_delay, **operation_config)
            elif polling is False: polling_method = NoPolling()
            else: polling_method = polling
            return LROPoller(self._client, raw_result, get_long_running_output, polling_method)
        post_restore.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints/{cloudEndpointName}/postrestore'}

        def _trigger_change_detection_initial(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, parameters, custom_headers=None, raw=False, **operation_config):
            # Construct URL
            url = self.trigger_change_detection.metadata['url']
            path_format_arguments = {
                'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str', min_length=1),
                'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str', max_length=90, min_length=1, pattern=r'^[-\w\._\(\)]+$'),
                'storageSyncServiceName': self._serialize.url("storage_sync_service_name", storage_sync_service_name, 'str'),
                'syncGroupName': self._serialize.url("sync_group_name", sync_group_name, 'str'),
                'cloudEndpointName': self._serialize.url("cloud_endpoint_name", cloud_endpoint_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str', min_length=1)

            # Construct headers
            header_parameters = {}
            header_parameters['Content-Type'] = 'application/json; charset=utf-8'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct body
            body_content = self._serialize.body(parameters, 'TriggerChangeDetectionParameters')

            # Construct and send request
            request = self._client.post(url, query_parameters, header_parameters, body_content)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200, 202]:
                raise models.StorageSyncErrorException(self._deserialize, response)

            if raw:
                client_raw_response = ClientRawResponse(None, response)
                header_dict = {
                    'Location': 'str',
                    'x-ms-request-id': 'str',
                    'x-ms-correlation-request-id': 'str',
                }
                client_raw_response.add_headers(header_dict)
                return client_raw_response

        def trigger_change_detection(
                self, resource_group_name, storage_sync_service_name, sync_group_name, cloud_endpoint_name, parameters, custom_headers=None, raw=False, polling=True, **operation_config):
            """Triggers detection of changes performed on Azure File share connected
            to the specified Azure File Sync Cloud Endpoint.

            :param resource_group_name: The name of the resource group. The name
             is case insensitive.
            :type resource_group_name: str
            :param storage_sync_service_name: Name of Storage Sync Service
             resource.
            :type storage_sync_service_name: str
            :param sync_group_name: Name of Sync Group resource.
            :type sync_group_name: str
            :param cloud_endpoint_name: Name of Cloud Endpoint object.
            :type cloud_endpoint_name: str
            :param parameters: Trigger Change Detection Action parameters.
            :type parameters:
             ~azure.mgmt.storagesync.models.TriggerChangeDetectionParameters
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: The poller return type is ClientRawResponse, the
             direct response alongside the deserialized response
            :param polling: True for ARMPolling, False for no polling, or a
             polling object for personal polling strategy
            :return: An instance of LROPoller that returns None or
             ClientRawResponse<None> if raw==True
            :rtype: ~msrestazure.azure_operation.AzureOperationPoller[None] or
             ~msrestazure.azure_operation.AzureOperationPoller[~msrest.pipeline.ClientRawResponse[None]]
            :raises:
             :class:`StorageSyncErrorException<azure.mgmt.storagesync.models.StorageSyncErrorException>`
            """
            raw_result = self._trigger_change_detection_initial(
                resource_group_name=resource_group_name,
                storage_sync_service_name=storage_sync_service_name,
                sync_group_name=sync_group_name,
                cloud_endpoint_name=cloud_endpoint_name,
                parameters=parameters,
                custom_headers=custom_headers,
                raw=True,
                **operation_config
            )

            def get_long_running_output(response):
                if raw:
                    client_raw_response = ClientRawResponse(None, response)
                    client_raw_response.add_headers({
                        'Location': 'str',
                        'x-ms-request-id': 'str',
                        'x-ms-correlation-request-id': 'str',
                    })
                    return client_raw_response

            lro_delay = operation_config.get(
                'long_running_operation_timeout',
                self.config.long_running_operation_timeout)
            if polling is True: polling_method = ARMPolling(lro_delay, **operation_config)
            elif polling is False: polling_method = NoPolling()
            else: polling_method = polling
            return LROPoller(self._client, raw_result, get_long_running_output, polling_method)
        trigger_change_detection.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.StorageSync/storageSyncServices/{storageSyncServiceName}/syncGroups/{syncGroupName}/cloudEndpoints/{cloudEndpointName}/triggerChangeDetection'}